VERSION 5.00
Begin VB.Form frmFirst 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "ODBC List"
   ClientHeight    =   2220
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3915
   Icon            =   "frmFirst.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2220
   ScaleWidth      =   3915
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cboDSNList 
      Height          =   315
      Left            =   480
      TabIndex        =   0
      Top             =   1320
      Width           =   2895
   End
   Begin VB.Frame Frame1 
      Caption         =   "Connection"
      Height          =   1575
      Left            =   360
      TabIndex        =   1
      Top             =   240
      Width           =   3135
      Begin VB.Label Label1 
         BorderStyle     =   1  'Fest Einfach
         Caption         =   "Bitte den Namen der zu benutzenden Datenbankverbindung angeben:"
         Height          =   555
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   2895
      End
   End
End
Attribute VB_Name = "frmFirst"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' Einfache Auflistung aller ODBC Datenquellen via API
' 06.2002 Ruru

Option Explicit

Private Declare Function SQLDataSources Lib "ODBC32.DLL" (ByVal _
        henv As Long, _
        ByVal fDirection As Integer, _
        ByVal szDSN As String, _
        ByVal cbDSNMax As Integer, _
        pcbDSN As Integer, _
        ByVal szDescription As String, _
        ByVal cbDescriptionMax As Integer, _
        pcbDescription As Integer) _
        As Integer
        
Private Declare Function SQLAllocEnv Lib "ODBC32.DLL" ( _
        env As Long) _
        As Integer

Const SQL_SUCCESS As Long = 0
Const SQL_FETCH_NEXT As Long = 1

Private Sub Form_Load()
  GetDSNsAndDrivers
  cboDSNList.ListIndex = 0
End Sub

Sub GetDSNsAndDrivers()
    Dim i As Integer
    Dim sDSNItem As String * 1024
    Dim sDRVItem As String * 1024
    Dim sDSN As String
    Dim sDRV As String
    Dim iDSNLen As Integer
    Dim iDRVLen As Integer
    Dim lHenv As Long         'Zugriffsnummer zur Umgebung

    On Error Resume Next
    cboDSNList.AddItem "(None)"

    'DSNs abrufen
    If SQLAllocEnv(lHenv) <> -1 Then
        Do Until i <> SQL_SUCCESS
            sDSNItem = Space(1024)
            sDRVItem = Space(1024)
            
            ' Aufruf der API Funktion zur Ausgabe der nchsten ODBC Verbindung
            i = SQLDataSources(lHenv, SQL_FETCH_NEXT, sDSNItem, 1024, iDSNLen, _
                sDRVItem, 1024, iDRVLen)
                
            sDSN = Left(sDSNItem, iDSNLen)
            sDRV = Left(sDRVItem, iDRVLen)
                
            If sDSN <> Space(iDSNLen) Then
                cboDSNList.AddItem sDSN
            End If
        Loop
    End If
End Sub
